#include<bits/stdc++.h>

using namespace std;

int n,m,k;
int a[2000010];
deque<int> stks[310];
bool nemp[310];
map<int,set<int>> tp;
map<int,set<int>> btm;

inline void init()
{
    memset(a,0,sizeof(a));
}

inline void getInput()
{
    cin >> n >> m >> k;
    for(int i=1; i<=m; i++) {
        cin >> a[i];
    }
}

void show()
{
    cout << "A:" << endl;
    for(int i=1; i<=m; i++) {
        cout << a[i] << ' ';
    }
    cout << endl;
    cout << "stks:" << endl;
    for(int i=1; i<=n; i++) {
        cout << i << " : ";
        for(auto it:stks[i]) {
            cout << it << ' ';
        }
        cout << endl;
    }
    cout << "Not Empty:" << endl;
    for(int i=1; i<=n; i++) {
        cout << nemp[i] << ' ';
    }
    cout << endl;
    cout << "top:" << endl;
    for(auto a : tp) {
        cout << a.first << " : ";
        for(auto it:a.second) {
            cout << it << ' ';
        }
        cout << endl;
    }
    cout << "bottom:" << endl;
    for(auto a : btm) {
        cout << a.first << " : ";
        for(auto it:a.second) {
            cout << it << ' ';
        }
        cout << endl;
    }
    cout << endl;
}

inline void solve()
{
    int cur;
    for(int i=1; i<=m; i++) {
        cur=a[i];
        if(tp.find(cur)!=tp.end()&&!tp[cur].empty()) {
            int nstk=*tp[cur].begin();
            cout << "1 " << nstk << endl;
            stks[nstk].pop_front();
            if(stks[nstk].empty()) {
                nemp[nstk]=false;
            }else{
                tp[stks[nstk].front()].insert(nstk);
            }
            tp[cur].erase(tp[cur].begin());
        }
        if(btm.find(cur)!=btm.end()&&!btm[cur].empty()) {
            int nstk=*btm[cur].begin();
            int estk=-1;
            for(int j=1; i<=n; i++) {
                if(!nemp[i]) {
                    estk=i;
                    break;
                }
            }
            if(estk!=-1) {
                cout << "1 " << estk << endl;
                cout << "2 " << estk << ' ' << nstk << endl;
                stks[nstk].pop_back();
                btm[cur].erase(btm[cur].begin());
            }
        }
        int estk=-1;
        for(int j=1; i<=n; i++) {
            if(!nemp[i]) {
                estk=i;
                break;
            }
        }
        if(estk!=-1) {
           cout << "1 " << estk << endl;
           tp[a[i]].insert(estk);
           btm[a[i]].insert(estk);
           nemp[estk]=true;
           stks[estk].push_front(a[i]); 
        }
        // show();
    }
}

int main()
{
    freopen("meow.in","r",stdin);
    freopen("meow.out","w",stdout);
    int T;
    cin >> T;
    for(int i=1; i<=T; i++) {
        init();
        getInput();
        solve();
    }
    return 0;
}